Feature: Synergy reports
	Background:
		Given I have these hostgroups configured:
			| hostgroup_name | alias      |
			| LinuxServers   | HGALIAS-ls |
			| WindowsServers | HGALIAS-ws |
			| MixedGroup     | HGALIAS-mg |
			| EmptyGroup     | HGALIAS-eg |
		And I have these hosts:
			| host_name      | host_groups               | alias      |
			| linux-server1  | LinuxServers,MixedGroup   | HALIAS-ls1 |
			| linux-server2  | LinuxServers              | HALIAS-ls2 |
			| win-server1    | WindowsServers            | HALIAS-ws1 |
			| win-server2    | WindowsServers,MixedGroup | HALIAS-ws2 |
		And I have these servicegroups:
			| servicegroup_name | alias     |
			| pings             | SGALIAS-p |
			| empty             | SGALIAS-e |
		And I have these services:
			| service_description | host_name     | check_command   | notifications_enabled | active_checks_enabled | service_groups |
			| System Load         | linux-server1 | check_nrpe!load | 1                     | 1                     |                |
			| PING                | linux-server1   | check_ping    | 1                     | 0                     | pings          |
			| System Load         | linux-server2 | check_nrpe!load | 1                     | 1                     |                |
			| PING                | win-server1   | check_ping      | 1                     | 0                     | pings          |
			| PING                | win-server2   | check_ping      | 0                     | 1                     | pings          |
		And I have these report data entries:
			| timestamp           | event_type | flags | attrib | host_name     | service_description | state | hard | retry | downtime_depth | output |
			| 2013-01-01 12:00:00 |        100 |  NULL |   NULL |               |                     |     0 |    0 |     0 |           NULL | NULL                |
			| 2013-01-01 12:00:01 |        801 |  NULL |   NULL | win-server1   |                     |     0 |    1 |     1 |           NULL | OK - laa-laa        |
			| 2013-01-01 12:00:02 |        801 |  NULL |   NULL | linux-server1 |                     |     0 |    1 |     1 |           NULL | OK - Sven Melander  |
			| 2013-01-01 12:00:03 |        701 |  NULL |   NULL | win-server1   | PING                |     0 |    1 |     1 |           NULL | OK - po             |
			| 2013-01-01 12:00:03 |        701 |  NULL |   NULL | win-server1   | PING                |     1 |    0 |     1 |           NULL | ERROR - tinky-winky |

		And I have these synergy report entries:
			| timestamp           | event_type | host_name     | service_description | state | tree |
			| 2013-01-01 12:00:03 |        701 | win-server1   | PING                |     1 | {"items":{"First":{"name":"First","status":1},"Third":{"name":"Third","status":1},"Second":{"name":"Second","status":2}},"type":"rule","name":"Test-Drive","args":{},"status":"WARNING","materialized":{"host":"192.168.1.159"},"result":{"host_contacts":{},"service_contacts":{},"status":1,"msg":"The best state is WARNING","last_state_change":0,"last_check":1357038003},"rule":"best_state"} |

		And I have activated the configuration

	@configuration @asmonitor @reports
	Scenario: Generate avail report for BSM-less host
		Given I am on the Host details page
		And I hover over the "Reporting" button
		When I click "Availability"
		And I select "Hosts" from "Report type"
		And I select "win-server2" from the multiselect "objects_tmp"
		Then "objects" should have option "win-server2"
		When I check "Include BSM events"
		And I select "Custom" from "Reporting period"
		And I enter "2013-01-01" into "Start date"
		And I enter "11:00" into "time_start"
		And I enter "2013-01-01" into "End date"
		And I enter "14:00" into "time_end"
		And I click "Show report"
		Then I should see "Host details for win-server2"
		And I should see "Selected services"
		And I should see "Group availability (Worst state)"
		And I should see "No Business Service Module events matching report criteria"

	@configuration @asmonitor @reports
	Scenario: Generate avail report for report period with no BSM event in range
		Given I am on the Host details page
		And I hover over the "Reporting" button
		When I click "Availability"
		And I select "Hosts" from "Report type"
		And I select "win-server1" from the multiselect "objects_tmp"
		Then "objects" should have option "win-server1"
		When I check "Include BSM events"
		And I click "Show report"
		Then I should see "Host details for win-server1"
		And I should see "Selected services"
		And I should see "Group availability (Worst state)"
		And I should see "No Business Service Module events matching report criteria"

	@configuration @asmonitor @reports
	Scenario: Generate avail report for report timeperiod with no BSM event in range
		Given I am on the Host details page
		And I hover over the "Reporting" button
		When I click "Availability"
		And I select "Hosts" from "Report type"
		And I select "win-server2" from the multiselect "objects_tmp"
		Then "objects" should have option "win-server2"
		When I check "Include BSM events"
		And I select "Custom" from "Reporting period"
		And I enter "2013-01-01" into "Start date"
		And I enter "11:00" into "time_start"
		And I enter "2013-01-01" into "End date"
		And I enter "14:00" into "time_end"
		And I select "nonworkhours" from "Report time period"
		And I click "Show report"
		Then I should see "Host details for win-server2"
		And I should see "Selected services"
		And I should see "Group availability (Worst state)"
		And I should see "No Business Service Module events matching report criteria"

	@configuration @asmonitor @reports
	Scenario: Generate single host avail report
		Given I am on the Host details page
		And I hover over the "Reporting" button
		When I click "Availability"
		And I select "Hosts" from "Report type"
		And I select "win-server1" from the multiselect "objects_tmp"
		Then "objects" should have option "win-server1"
		When I check "Include BSM events"
		And I select "Custom" from "Reporting period"
		And I enter "2013-01-01" into "Start date"
		And I enter "11:00" into "time_start"
		And I enter "2013-01-01" into "End date"
		And I enter "14:00" into "time_end"
		And I click "Show report"
		Then I should see "Host details for win-server1"
		And I should see "Selected services"
		And I should see "Group availability (Worst state)"
		And I should see "Business Service Module events"
		And I should see "The best state is WARNING"

	@configuration @asmonitor @reports
	Scenario: Generate hostgroup avail report
		Given I am on the Host details page
		And I hover over the "Reporting" button
		When I click "Availability"
		And I select "WindowsServers" from the multiselect "objects_tmp"
		Then "objects" should have option "WindowsServers"
		When I check "Include BSM events"
		And I select "Custom" from "Reporting period"
		And I enter "2013-01-01" into "Start date"
		And I enter "11:00" into "time_start"
		And I enter "2013-01-01" into "End date"
		And I enter "14:00" into "time_end"
		And I click "Show report"
		Then I should see "Hostgroup breakdown"
		And I should see "Group availability (Worst state)"
		And I should see "Business Service Module events"
		And I should see "The best state is WARNING"

	@configuration @asmonitor @reports
	Scenario: Generate single service avail report
		Given I am on the Host details page
		And I hover over the "Reporting" button
		When I click "Availability"
		And I select "Services" from "Report type"
		And I select "win-server1;PING" from the multiselect "objects_tmp"
		Then "objects" should have option "win-server1;PING"
		When I check "Include BSM events"
		And I select "Custom" from "Reporting period"
		And I enter "2013-01-01" into "Start date"
		And I enter "11:00" into "time_start"
		And I enter "2013-01-01" into "End date"
		And I enter "14:00" into "time_end"
		And I click "Show report"
		Then I should see "Service details for PING on host win-server1"
		And I should see "Business Service Module events"
		And I should see "The best state is WARNING"

	@configuration @asmonitor @reports
	Scenario: Generate servicegroup avail report
		Given I am on the Host details page
		And I hover over the "Reporting" button
		When I click "Availability"
		And I select "Servicegroups" from "Report type"
		And I select "pings" from the multiselect "objects_tmp"
		Then "objects" should have option "pings"
		When I check "Include BSM events"
		And I select "Custom" from "Reporting period"
		And I enter "2013-01-01" into "Start date"
		And I enter "11:00" into "time_start"
		And I enter "2013-01-01" into "End date"
		And I enter "14:00" into "time_end"
		And I click "Show report"
		Then I should see "Servicegroup breakdown"
		And I should see "Group availability (Worst state)"
		And I should see "Business Service Module events"
		And I should see "The best state is WARNING"
